## libsdl3 3.1.8+ds

=== debian/changelog ===
libsdl3 (3.1.8+ds-1) unstable; urgency=medium

  * New upstream release
  * d/libsdl3-doc.manpages: Update
  * d/libsdl3-0.symbols: Update
  * d/control: Build-depend on liburing-dev on Linux architectures
  * d/copyright: Stop excluding files that no longer exist upstream
  * d/copyright: Stop excluding Valve's OpenVR header file.
    It has been placed under a DFSG-compliant license.
  * d/copyright: Update
  * d/rules: Use the same test timeout multipliers as GLib.
    amd64 and i386 are known to be "fast" architectures, likely to be used
    for interactive debugging, and unlikely to be emulated with qemu,
    so use a closer-to-normal timeout that will not be intolerably long
    for developers. Other architectures might be using slow hardware or
    extremely slow qemu-emulated buildds, so use a much longer timeout.
  * d/rules: Apply test timeout multiplier to all tests.
    A few tests use SDL_TESTS_TIMEOUT_MULTIPLIER, but most use
    SDLTEST_TIMEOUT_MULTIPLIER, because test/ behaves like a subproject.
    Set both. (Closes: #1091884)
  * d/rules: Ensure that shaders are output in a deterministic order
  * d/p/tray-Create-tray-icons-for-libappindicator-securely.patch:
    Add proposed patch to fix a /tmp symlink attack when
    providing icons to lib[ayatana-]appindicator. Regression post-3.1.6.
  * d/control: Add Recommends on various dlopen'd libraries:
    libdbus, libEGL, libGL | libOpenGL, libGLESv2, libudev.
    These are not hard dependencies, but will be desirable for
    many games.
  * d/control: Add Suggests on various other dlopen'd libraries:
    libayatana-appindicator3, libpipewire-0.3, liburing, libvulkan.
    These are not always necessary, but will be desirable for some games
    and for some systems.
  * d/watch*: Make removal of git snapshot suffix more flexible
  * d/watch: Watch for prereleases until 3.2.0 is out
  * d/watch.git: Use current preview release version number

 -- Simon McVittie <smcv@debian.org>  Wed, 08 Jan 2025 14:50:36 +0000

=== debian/control ===
Source: libsdl3
Priority: optional
Section: libs
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Manuel A. Fernandez Montecelo <mafm@debian.org>,
 Felix Geyer <fgeyer@debian.org>,
 Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.0
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 fcitx-libs-dev,
 glslang-tools,
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev (>= 0.2.0) [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpipewire-0.3-dev (>= 0.3.44) [linux-any],
 libpulse-dev,
 libsndio-dev,
 libudev-dev [linux-any],
 liburing-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libvulkan-dev [linux-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 pkgconf,
 wayland-protocols,
 xxd,
Build-Depends-Indep:
 graphviz <!nodoc>,
 doxygen <!nodoc>,
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl3.git
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl3
Homepage: https://www.libsdl.org/
Rules-Requires-Root: no

Package: libsdl3-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libdbus-1-3,
 libegl1,
 libgl1 | libopengl0,
 libgles2,
 libudev1 [linux-any],
Suggests:
 libayatana-appindicator3-1 | libappindicator3-1,
 libpipewire-0.3-0t64 [linux-any],
 liburing2 [linux-any],
 libvulkan1,
 xdg-utils,
Description: Simple DirectMedia Layer, version 3
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This version of SDL is under development and its API and ABI are not stable.
 Use libsdl2-dev for new programs until a stable release of SDL 3 has
 been made: the first stable release is expected to be versioned as 3.2.0.

Package: libsdl3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libdecor-0-dev (>= 0.2.0) [linux-any],
 libdrm-dev [linux-any],
 libegl-dev [!hurd-any],
 libgbm-dev [linux-any],
 libgl-dev,
 libgles-dev [!hurd-any],
 libibus-1.0-dev,
 libpulse-dev,
 libsdl3-0 (= ${binary:Version}),
 libsndio-dev,
 libudev-dev [linux-any],
 libusb2-dev [kfreebsd-any],
 libusbhid-dev [kfreebsd-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxfixes-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 libxss-dev,
 libxt-dev,
 libxv-dev,
 libxxf86vm-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Description: Simple DirectMedia Layer, version 3 development files
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This version of SDL is under development and its API and ABI are not stable.
 Use libsdl2-dev for new programs until a stable release of SDL 3 has
 been made: the first stable release is expected to be versioned as 3.2.0.
 .
 This package contains the files needed to compile and link programs which
 use SDL.

Package: libsdl3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Breaks:
 libsdl1.2-dev (<< 1.2.64),
Replaces:
 libsdl1.2-dev (<< 1.2.64),
Description: Reference manual for SDL 3
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains the reference manual and examples.

Package: libsdl3-tests
Section: misc
Architecture: any
Build-Profiles: <!noinsttest>
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 gnome-desktop-testing
Description: Simple DirectMedia Layer automated and manual tests
 SDL is a library that allows programs portable low level access to a video
 framebuffer, audio output, mouse, and keyboard.
 .
 This package contains manual and automated tests. The automated tests can
 be run using ginsttest-runner in the gnome-desktop-testing package,
 or manually.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

built_binaries := $(shell dh_listpackages)

include /usr/share/dpkg/default.mk

export SDL_AUDIO_DRIVER=dummy
export SDL_VIDEO_DRIVER=dummy

# Upstream test timeouts assume a gaming-capable system.
# Keep the timeout reasonably short for architectures where interactive
# debugging is more likely, but extend it a lot on architectures that might
# be very slow or using qemu for buildds.
ifneq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
test_timeout_multiplier = 3
else
test_timeout_multiplier = 20
endif

confflags = \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	-DSDL_ALSA_SHARED=OFF \
	-DSDL_EXAMPLES=ON \
	-DSDL_HIDAPI_LIBUSB_SHARED=OFF \
	-DSDL_JACK=OFF \
	-DSDL_JACK_SHARED=OFF \
	-DSDL_KMSDRM_SHARED=OFF \
	-DSDL_OSS=OFF \
	-DSDL_PIPEWIRE_SHARED=ON \
	-DSDL_PULSEAUDIO_SHARED=OFF \
	-DSDL_RPATH=OFF \
	-DSDL_RPI=OFF \
	-DSDL_SHARED=ON \
	-DSDL_SNDIO_SHARED=ON \
	-DSDL_STATIC=ON \
	-DSDL_STATIC_PIC=ON \
	-DSDL_TESTS=ON \
	-DSDL_TESTS_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	-DSDL_TEST_LIBRARY=ON \
	-DSDL_VENDOR_INFO="${DEB_VENDOR} ${DEB_VERSION}" \
	-DSDL_VIVANTE=OFF \
	-DSDL_X11=ON \
	-DSDL_X11_SHARED=OFF \
	-DSDLTEST_TIMEOUT_MULTIPLIER=$(test_timeout_multiplier) \
	$(NULL)

ifneq ($(filter %-tests,$(built_binaries)),)
  confflags += -DSDL_INSTALL_EXAMPLES=ON
  confflags += -DSDL_INSTALL_TESTS=ON
endif

ifeq ($(filter %-doc,$(built_binaries)),)
  confflags += -DSDL_DISABLE_INSTALL_DOCS=ON
else
  confflags += -DSDL_DISABLE_INSTALL_DOCS=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU),ppc64el)
  confflags += -DSDL_ALTIVEC=OFF
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  confflags += -DSDL_WAYLAND=ON
  confflags += -DSDL_WAYLAND_SHARED=OFF
else
  confflags += -DSDL_WAYLAND=OFF
endif

#ifeq ($(DEB_VERSION_UPSTREAM),3.1.6+git20250107+ds)
#  confflags += -DSDL_REVISION=preview-3.1.6-639-g0176a19aee
#endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	set -e; for bmp in test/icon.bmp test/gamepad_*.bmp test/glass.bmp; do \
		python3 cmake/xxd.py -i "$${bmp}" -o "$${bmp%.bmp}.h"; \
	done
	cd build-scripts && ./makecasefoldhashtable.pl > ../src/stdlib/SDL_casefolding.h
	cd src/render/gpu/shaders && LC_ALL=C bash -ex ./build-shaders.sh
	# This is intended as a Windows batch file, but at the time of writing
	# it's so simple that it's also a valid shell script
	cd src/render/vulkan && sh -ex ./compile_shaders.bat
	cd test/testgpu && OSTYPE=$(DEB_HOST_ARCH_OS) bash -ex ./build-shaders.sh
	cp debian/placeholders/testgpu_*.h test/testgpu/
	dh_auto_configure -- $(confflags)

execute_after_dh_auto_build:
ifneq ($(filter %-doc,$(built_binaries)),)
	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile
	cd docs && doxygen ../debian/Doxyfile
	# useless files
	find docs/output -name "*.md5" -delete
	find docs/output -type d -empty -delete
endif

execute_after_dh_auto_clean-indep:
	rm -f debian/Doxyfile
	rm -rf docs/output

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-examples -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-examples
	chmod --recursive --changes a+rX,u+w,og-w debian/libsdl3-tests/usr/libexec/installed-tests
endif

override_dh_installchangelogs:
	dh_installchangelogs -- WhatsNew.txt

=== debian/tests/control ===
Tests: build
Depends: build-essential, clang:native, libsdl3-dev, pkgconf
Restrictions: superficial, allow-stderr

Tests: cmake
Depends: build-essential, cmake, libsdl3-dev, pkgconf
Restrictions: superficial, allow-stderr

Tests: installed-tests
Depends: gnome-desktop-testing, libsdl3-tests
Restrictions: superficial, allow-stderr

=== debian/watch ===
version=4
# Upstream releases official source tarballs, so we use
# those in preference to git tags
opts="\
    compression=xz, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)?//;s/[+~](?:ds|dfsg)[0-9]*//, \
    downloadurlmangle=s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL3-$2.tar.gz#, \
    filenamemangle=s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL3-$1.tar.gz#, \
    pgpmode=none, \
    repack, \
    repacksuffix=+ds" \
https://github.com/libsdl-org/SDL/tags .*/releases/tag/(?:prerelease|preview|release)-?@ANY_VERSION@

## libsdl3 3.1.10+ds

=== debian/changelog ===
libsdl3 (3.1.10+ds-1) unstable; urgency=medium

  * New upstream release candidate
  * d/watch*: Fix dversionmangle expression
  * d/libsdl3-0.symbols: Depend on 3.1.8 for symbols introduced after 3.1.6
  * d/rules: Update build options for 3.1.10
  * d/copyright: Exclude more unneeded MSVC-related files
  * d/libsdl3-0.symbols: Update with new symbols in 3.1.10
  * d/p/tray-Create-tray-icons-for-libappindicator-securely.patch:
    Drop patch, applied upstream
  * d/p/Fixed-warning-C6313-Incorrect-operator.-Use-an-equality-t.patch,
    d/p/x11-check-to-see-if-displays-moved-when-connected-disconn.patch,
    d/p/storage-enumerate-and-glob-on-storage-can-accept-a-NULL-p.patch,
    d/p/Fixed-sine-wave-distortion-over-time.patch,
    d/p/Fixed-wrong-type-of-phase-12014.patch,
    d/p/Added-support-for-the-8BitDo-Ultimate-2C-Wireless-in-Blue.patch,
    d/p/Added-Linux-evdev-mappings-for-the-Wireless-HORIPAD-For-S.patch,
    d/p/wayland-Set-the-mouse-state-before-calling-the-hit-test-c.patch,
    d/p/Use-SDL_calloc-instead-of-SDL_malloc.patch,
    d/p/pen-Send-virtual-mouse-motion-without-a-button-press-when.patch:
    Add post-release bug fixes up to prerelease-3.1.10-47-g32965b4bf
  * d/docs: README-SDL.txt no longer exists

 -- Simon McVittie <smcv@debian.org>  Sun, 19 Jan 2025 14:43:56 +0000

=== debian/watch ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # those in preference to git tags
 opts="\
     compression=xz, \
-    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)?//;s/[+~](?:ds|dfsg)[0-9]*//, \
+    dversionmangle=s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//, \
     downloadurlmangle=s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL3-$2.tar.gz#, \
     filenamemangle=s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL3-$1.tar.gz#, \
     pgpmode=none, \

## libsdl3 3.2.0+ds

=== debian/changelog ===
libsdl3 (3.2.0+ds-1) unstable; urgency=medium

  * New upstream stable release (Closes: #1086720)
  * d/libsdl3-0.symbols: Add one new symbol
  * d/libsdl3-0.symbols: Generate dependencies on 3.2.0 stable release
  * d/patches: Drop all patches, included in the upstream stable release
  * d/control: Update package descriptions to reflect stable status
  * d/watch: Only watch for stable releases

 -- Simon McVittie <smcv@debian.org>  Tue, 21 Jan 2025 19:46:42 +0000

=== debian/control ===
--- 
+++ 
@@ -74,12 +74,10 @@
  libvulkan1,
  xdg-utils,
 Description: Simple DirectMedia Layer, version 3
- SDL is a library that allows programs portable low level access to a video
- framebuffer, audio output, mouse, and keyboard.
+ SDL is a cross-platform library designed to make it easy to write
+ multimedia software such as games and emulators.
  .
- This version of SDL is under development and its API and ABI are not stable.
- Use libsdl2-dev for new programs until a stable release of SDL 3 has
- been made: the first stable release is expected to be versioned as 3.2.0.
+ This package contains the shared library.
 
 Package: libsdl3-dev
 Section: libdevel
@@ -117,12 +115,8 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Description: Simple DirectMedia Layer, version 3 development files
- SDL is a library that allows programs portable low level access to a video
- framebuffer, audio output, mouse, and keyboard.
- .
- This version of SDL is under development and its API and ABI are not stable.
- Use libsdl2-dev for new programs until a stable release of SDL 3 has
- been made: the first stable release is expected to be versioned as 3.2.0.
+ SDL is a cross-platform library designed to make it easy to write
+ multimedia software such as games and emulators.
  .
  This package contains the files needed to compile and link programs which
  use SDL.
@@ -139,8 +133,8 @@
 Replaces:
  libsdl1.2-dev (<< 1.2.64),
 Description: Reference manual for SDL 3
- SDL is a library that allows programs portable low level access to a video
- framebuffer, audio output, mouse, and keyboard.
+ SDL is a cross-platform library designed to make it easy to write
+ multimedia software such as games and emulators.
  .
  This package contains the reference manual and examples.
 
@@ -154,8 +148,8 @@
 Suggests:
  gnome-desktop-testing
 Description: Simple DirectMedia Layer automated and manual tests
- SDL is a library that allows programs portable low level access to a video
- framebuffer, audio output, mouse, and keyboard.
+ SDL is a cross-platform library designed to make it easy to write
+ multimedia software such as games and emulators.
  .
  This package contains manual and automated tests. The automated tests can
  be run using ginsttest-runner in the gnome-desktop-testing package,

## libsdl3 3.2.2%2Bds

=== debian/changelog ===
libsdl3 (3.2.2+ds-1) unstable; urgency=medium

  * New upstream stable release

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Feb 2025 13:58:20 +0000

=== debian/rules ===
--- 
+++ 
@@ -52,9 +52,9 @@
 endif
 
 ifeq ($(filter %-doc,$(built_binaries)),)
-  confflags += -DSDL_DISABLE_INSTALL_DOCS=ON
+  confflags += -DSDL_INSTALL_DOCS=OFF
 else
-  confflags += -DSDL_DISABLE_INSTALL_DOCS=OFF
+  confflags += -DSDL_INSTALL_DOCS=ON
 endif
 
 ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
@@ -92,6 +92,9 @@
 	cp debian/placeholders/testgpu_*.h test/testgpu/
 	dh_auto_configure -- $(confflags)
 
+override_dh_auto_test:
+	true
+
 execute_after_dh_auto_build:
 ifneq ($(filter %-doc,$(built_binaries)),)
 	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile

## libsdl3 3.2.4+ds

=== debian/changelog ===
libsdl3 (3.2.4+ds-2deepin1) unstable; urgency=medium

  * revert t64

 -- lhdjply <lhdjply@126.com>  Mon, 17 Feb 2025 16:01:25 +0800

libsdl3 (3.2.4+ds-2) unstable; urgency=medium

  * d/patches: Add post-release bug fixes up to
    release-3.2.4-18-g4fd0b2a85c, excluding N3DS- and Windows-specific
    changes

 -- Simon McVittie <smcv@debian.org>  Mon, 10 Feb 2025 18:01:25 +0000

libsdl3 (3.2.4+ds-1) unstable; urgency=medium

  * New upstream stable release
    - Unusually, this one adds new API/ABI.
  * d/libsdl3-0.symbols: Update
  * d/copyright: Update Source to match debian/watch
  * d/control: Build-depend on glslang-tools (>= 12).
    Other versions might work, but this version (from Debian 12) is the
    oldest that has successfully been tested in the Steam Runtime.
  * d/tests/control: Stop treating installed-tests as superficial.
    These have reasonably good coverage now that we run testautomation.

 -- Simon McVittie <smcv@debian.org>  Fri, 07 Feb 2025 17:52:55 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  cmake,
  debhelper-compat (= 13),
  fcitx-libs-dev,
- glslang-tools,
+ glslang-tools (>= 12),
  libasound2-dev [linux-any],
  libdbus-1-dev,
  libdecor-0-dev (>= 0.2.0) [linux-any],
@@ -69,7 +69,7 @@
  libudev1 [linux-any],
 Suggests:
  libayatana-appindicator3-1 | libappindicator3-1,
- libpipewire-0.3-0t64 [linux-any],
+ libpipewire-0.3-0 [linux-any],
  liburing2 [linux-any],
  libvulkan1,
  xdg-utils,

=== debian/rules ===
--- 
+++ 
@@ -92,9 +92,6 @@
 	cp debian/placeholders/testgpu_*.h test/testgpu/
 	dh_auto_configure -- $(confflags)
 
-override_dh_auto_test:
-	true
-
 execute_after_dh_auto_build:
 ifneq ($(filter %-doc,$(built_binaries)),)
 	sed -e 's/FULL_PATH_NAMES *=.*/FULL_PATH_NAMES = NO/' < docs/doxyfile > debian/Doxyfile

=== debian/tests/control ===
--- 
+++ 
@@ -8,4 +8,4 @@
 
 Tests: installed-tests
 Depends: gnome-desktop-testing, libsdl3-tests
-Restrictions: superficial, allow-stderr
+Restrictions: allow-stderr

## libsdl3 3.2.4+git20250218+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(cmake_build_type_undefined 1)
endif()

# See docs/release_checklist.md
project(SDL3 LANGUAGES C VERSION "3.2.5")

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(SDL3_MAINPROJECT ON)
else()
  set(SDL3_MAINPROJECT OFF)
endif()

# Add UTF-8 encoding support for MSVC compiler.
# This ensures that the MSVC compiler interprets source files as UTF-8 encoded,
# which is useful for projects containing non-ASCII characters in source files.
add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")

# By default, configure SDL3 in RelWithDebInfo configuration
if(SDL3_MAINPROJECT)
  get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(is_multi_config)
      # The first item in CMAKE_CONFIGURATION_TYPES is the default configuration
      if(DEFINED CMAKE_CONFIGURATION_TYPES AND "RelWithDebInfo" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(REMOVE_ITEM CMAKE_CONFIGURATION_TYPES "RelWithDebInfo")
        list(INSERT CMAKE_CONFIGURATION_TYPES 0 "RelWithDebInfo")
        set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING "CMake configuration types" FORCE)
      endif()
  else()
    if(cmake_build_type_undefined)
      set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "CMake build type" FORCE)
    endif()
  endif()
endif()

# CMake 3.0 expands the "if(${A})" in "set(OFF 1);set(A OFF);if(${A})" to "if(1)"
# CMake 3.24+ emits a warning when not set.
unset(OFF)
unset(ON)
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckLanguage)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckStructHasMember)
include(CMakeDependentOption)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(GNUInstallDirs)

if(NOT DEFINED OpenGL_GL_PREFERENCE)
  set(OpenGL_GL_PREFERENCE GLVND)
endif()

find_package(PkgConfig)

list(APPEND CMAKE_MODULE_PATH "${SDL3_SOURCE_DIR}/cmake")
include("${SDL3_SOURCE_DIR}/cmake/macros.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlchecks.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlcompilers.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlcpu.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlmanpages.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdlplatform.cmake")
include("${SDL3_SOURCE_DIR}/cmake/sdltargets.cmake")
include("${SDL3_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake")
include("${SDL3_SOURCE_DIR}/cmake/3rdparty.cmake")
include("${SDL3_SOURCE_DIR}/cmake/PreseedMSVCCache.cmake")
include("${SDL3_SOURCE_DIR}/cmake/PreseedEmscriptenCache.cmake")

SDL_DetectCompiler()
SDL_DetectTargetCPUArchitectures(SDL_CPUS)

# Increment this if there is an incompatible change - but if that happens,
# we should rename the library from SDL3 to SDL4, at which point this would
# reset to 0 anyway.
set(SDL_SO_VERSION_MAJOR "0")
set(SDL_SO_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(SDL_SO_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(SDL_SO_VERSION "${SDL_SO_VERSION_MAJOR}.${SDL_SO_VERSION_MINOR}.${SDL_SO_VERSION_PATCH}")

if(PROJECT_VERSION_MINOR MATCHES "[02468]$")
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${PROJECT_VERSION_MINOR} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "${PROJECT_VERSION_PATCH}")
else()
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${PROJECT_VERSION_MINOR} + ${PROJECT_VERSION_PATCH} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "0")
endif()
set(SDL_DYLIB_CURRENT_VERSION_PATCH "0")
set(SDL_DYLIB_COMPAT_VERSION_PATCH "0")

set(SDL_DYLIB_CURRENT_VERSION "${SDL_DYLIB_CURRENT_VERSION_MAJOR}.${SDL_DYLIB_CURRENT_VERSION_MINOR}.${SDL_DYLIB_CURRENT_VERSION_PATCH}")
set(SDL_DYLIB_COMPAT_VERSION "${SDL_DYLIB_COMPAT_VERSION_MAJOR}.${SDL_DYLIB_COMPAT_VERSION_MINOR}.${SDL_DYLIB_COMPAT_VERSION_PATCH}")

message(DEBUG "SDL_SO_VERSION=${SDL_SO_VERSION} SDL_DYLIB_CURRENT_VERSION=${SDL_DYLIB_CURRENT_VERSION} SDL_DYLIB_COMPAT_VERSION=${SDL_DYLIB_COMPAT_VERSION}")

set(SDL_FRAMEWORK_VERSION "A")

set(SDL_CHECK_REQUIRED_INCLUDES "" CACHE STRING "Extra includes (for CMAKE_REQUIRED_INCLUDES)")
set(SDL_CHECK_REQUIRED_LINK_OPTIONS "" CACHE STRING "Extra link options (for CMAKE_REQUIRED_LINK_OPTIONS)")
mark_as_advanced(SDL_CHECK_REQUIRED_INCLUDES SDL_CHECK_REQUIRED_LINK_OPTIONS)

string(APPEND CMAKE_REQUIRED_FLAGS " -D_GNU_SOURCE=1")
list(APPEND CMAKE_REQUIRED_INCLUDES ${SDL_CHECK_REQUIRED_INCLUDES})
list(APPEND CMAKE_REQUIRED_LINK_OPTIONS ${SDL_CHECK_REQUIRED_LINK_OPTIONS})

# Get the platform
SDL_DetectCMakePlatform()

# Don't mistake macOS for unix
if(UNIX AND NOT ANDROID AND NOT APPLE AND NOT RISCOS)
  set(UNIX_SYS ON)
else()
  set(UNIX_SYS OFF)
endif()

if(UNIX OR APPLE)
  set(UNIX_OR_MAC_SYS ON)
else()
  set(UNIX_OR_MAC_SYS OFF)
endif()

# Emscripten pthreads work, but you need to have a non-pthread fallback build
#  for systems without support. It's not currently enough to not use
#  pthread functions in a pthread-build; it won't start up on unsupported
#  browsers. As such, you have to explicitly enable it on Emscripten builds
#  for the time being. This default will change to ON once this becomes
#  commonly supported in browsers or the Emscripten team makes a single
#  binary work everywhere.
if (UNIX_OR_MAC_SYS AND NOT EMSCRIPTEN)
  set(SDL_PTHREADS_DEFAULT ON)
else()
  set(SDL_PTHREADS_DEFAULT OFF)
endif()

if(UNIX_SYS OR ANDROID)
  set(SDL_CLOCK_GETTIME_DEFAULT ON)
else()
  set(SDL_CLOCK_GETTIME_DEFAULT OFF)
endif()

# The hidraw support doesn't catch Xbox, PS4 and Nintendo controllers,
#  so we'll just use libusb when it's available. libusb does not support iOS,
#  so we default to yes on iOS.
if(IOS OR TVOS OR VISIONOS OR WATCHOS OR ANDROID)
  set(SDL_HIDAPI_LIBUSB_AVAILABLE FALSE)
else()
  set(SDL_HIDAPI_LIBUSB_AVAILABLE TRUE)
endif()

set(SDL_ASSEMBLY_DEFAULT OFF)
if(USE_CLANG OR USE_GCC OR USE_INTELCC OR MSVC_VERSION GREATER 1400)
  set(SDL_ASSEMBLY_DEFAULT ON)
endif()

set(SDL_GCC_ATOMICS_DEFAULT OFF)
if(USE_GCC OR USE_CLANG OR USE_INTELCC OR USE_QCC)
  set(SDL_GCC_ATOMICS_DEFAULT ON)
endif()

# Default option knobs
set(SDL_LIBC_DEFAULT ON)
set(SDL_SYSTEM_ICONV_DEFAULT ON)
if(WINDOWS OR MACOS OR IOS OR TVOS OR VISIONOS OR WATCHOS)
  set(SDL_SYSTEM_ICONV_DEFAULT OFF)
endif()

set(SDL_RELOCATABLE_DEFAULT OFF)
if(MSVC)
  set(SDL_RELOCATABLE_DEFAULT ON)
endif()

if(MSVC)
  if(NOT SDL_LIBC)
    # Make sure /RTC1 is disabled, otherwise it will use functions from the CRT
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
  endif()

  if(MSVC_CLANG)
    # clang-cl treats /W4 as '-Wall -Wextra' -- we don't need -Wextra
    foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      string(REGEX REPLACE "/W4" "/W3" ${flag_var} "${${flag_var}}")
    endforeach(flag_var)
  endif()
endif()

set(SDL_SHARED_DEFAULT ON)
set(SDL_STATIC_DEFAULT ON)

set(SDL_SHARED_AVAILABLE ON)
set(SDL_STATIC_AVAILABLE ON)

# All these *_DEFAULT vars will default to ON if not specified,
# so you only need to override them if they need to be disabled.
if(EMSCRIPTEN)
  # Set up default values for the currently supported set of subsystems:
  # Emscripten/Javascript does not have assembly support, a dynamic library
  # loading architecture, or low-level CPU inspection.
  set(SDL_ASSEMBLY_DEFAULT OFF)
  set(SDL_SHARED_AVAILABLE OFF)
endif()

if(VITA OR PSP OR PS2 OR N3DS OR RISCOS)
  set(SDL_SHARED_AVAILABLE OFF)
endif()

if((RISCOS OR UNIX_SYS) AND NOT (LINUX OR NETBSD OR OPENBSD))
  set(SDL_OSS_DEFAULT ON)
else()
  set(SDL_OSS_DEFAULT OFF)
endif()

if(SDL_SHARED_DEFAULT AND SDL_STATIC_DEFAULT AND SDL_SHARED_AVAILABLE)
  if(DEFINED BUILD_SHARED_LIBS)
    # When defined, use BUILD_SHARED_LIBS as default
    if(BUILD_SHARED_LIBS)
      set(SDL_STATIC_DEFAULT OFF)
    else()
      set(SDL_SHARED_DEFAULT OFF)
    endif()
  else()
    # Default to just building the shared library
    set(SDL_STATIC_DEFAULT OFF)
  endif()
endif()

dep_option(SDL_DEPS_SHARED "Load dependencies dynamically" ON SDL_SHARED_AVAILABLE OFF)

set(SDL_SUBSYSTEMS )

macro(define_sdl_subsystem _name)
  cmake_parse_arguments("_ds" "" "" "DEPS" ${ARGN})
  string(TOUPPER ${_name} _uname)
  if(NOT DEFINED SDL_${_uname}_DEFAULT)
    set(SDL_${_uname}_DEFAULT ON)
  endif()
  if(_ds_DEPS)
    cmake_dependent_option(SDL_${_uname} "Enable the ${_name} subsystem" "${SDL_${_uname}_DEFAULT}" "${_ds_DEPS}" OFF)
  else()
    option(SDL_${_uname} "Enable the ${_name} subsystem" "${SDL_${_uname}_DEFAULT}")
  endif()
  list(APPEND SDL_SUBSYSTEMS "${_name}")
endmacro()

define_sdl_subsystem(Audio)
define_sdl_subsystem(Video)
define_sdl_subsystem(GPU DEPS SDL_VIDEO)
define_sdl_subsystem(Render DEPS SDL_VIDEO)
define_sdl_subsystem(Camera DEPS SDL_VIDEO)
define_sdl_subsystem(Joystick)
define_sdl_subsystem(Haptic)
define_sdl_subsystem(Hidapi)
define_sdl_subsystem(Power)
define_sdl_subsystem(Sensor)
define_sdl_subsystem(Dialog)

cmake_dependent_option(SDL_FRAMEWORK "Build SDL libraries as Apple Framework" OFF "APPLE" OFF)
if(SDL_FRAMEWORK)
  set(SDL_STATIC_AVAILABLE FALSE)
endif()

if(UNIX AND NOT ANDROID AND NOT RISCOS AND NOT SDL_FRAMEWORK)
  set(SDL_RPATH_DEFAULT ON)
else()
  set(SDL_RPATH_DEFAULT OFF)
endif()

set(SDL_PRESEED_AVAILABLE OFF)
if(COMMAND SDL_Preseed_CMakeCache)
  set(SDL_PRESEED_AVAILABLE ON)
endif()

set(SDL_X11_XRANDR_DEFAULT ON)
if(SOLARIS)
  set(SDL_X11_XRANDR_DEFAULT OFF)
endif()

# Allow some projects to be built conditionally.
set_option(SDL_INSTALL             "Enable installation of SDL3" ${SDL3_MAINPROJECT})
cmake_dependent_option(SDL_INSTALL_CPACK "Create binary SDL3 archive using CPack" ${SDL3_MAINPROJECT} "SDL_INSTALL" ON)
cmake_dependent_option(SDL_INSTALL_DOCS "Install docs for SDL3" OFF "SDL_INSTALL;NOT SDL_FRAMEWORK" ON)
set_option(SDL_UNINSTALL           "Enable uninstallation of SDL3" ${SDL3_MAINPROJECT})
cmake_dependent_option(SDL_PRESEED "Preseed CMake cache to speed up configuration" ON "${SDL_PRESEED_AVAILABLE}" OFF)
cmake_dependent_option(SDL_RELOCATABLE "Create relocatable SDL package" ${SDL_RELOCATABLE_DEFAULT} "SDL_INSTALL" OFF)

cmake_dependent_option(SDL_ANDROID_JAR  "Enable creation of SDL3.jar" ${SDL3_MAINPROJECT} "ANDROID" ON)

option_string(SDL_ASSERTIONS "Enable internal sanity checks (auto/disabled/release/enabled/paranoid)" "auto")
set_option(SDL_ASSEMBLY            "Enable assembly routines" ${SDL_ASSEMBLY_DEFAULT})
dep_option(SDL_AVX                 "Use AVX assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_AVX2                "Use AVX2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_AVX512F             "Use AVX512F assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE                 "Use SSE assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE2                "Use SSE2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE3                "Use SSE3 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE4_1              "Use SSE4.1 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)
dep_option(SDL_SSE4_2              "Use SSE4.2 assembly routines" ON "SDL_ASSEMBLY;SDL_CPU_X86 OR SDL_CPU_X64" OFF)

=== test/CMakeLists.txt ===
#
# CMake script for building the SDL tests
#

cmake_minimum_required(VERSION 3.16)

set(SDL3_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/..")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/../cmake")

include(CheckIncludeFile)
include(CheckStructHasMember)
include(CMakePushCheckState)
include(sdlcompilers)

find_package(Python3 COMPONENTS Interpreter)
if(NOT PYTHON3_EXECUTABLE)
    set(PYTHON3_EXECUTABLE "python3")
endif()

if(SDL_TESTS_LINK_SHARED)
    set(sdl_name_component SDL3-shared)
else()
    set(sdl_name_component SDL3-static)
endif()
set(HAVE_TESTS_LINK_SHARED "${SDL_TESTS_LINK_SHARED}" PARENT_SCOPE)

# CMake incorrectly detects opengl32.lib being present on MSVC ARM64
if(NOT (MSVC AND SDL_CPU_ARM64))
    # Prefer GLVND, if present
    set(OpenGL_GL_PREFERENCE GLVND)
    find_package(OpenGL)
endif()

set(SDL_TEST_EXECUTABLES)

add_library(sdltests_utils OBJECT
    testutils.c
)
target_link_libraries(sdltests_utils PRIVATE SDL3::Headers)

file(GLOB RESOURCE_FILES *.bmp *.wav *.hex moose.dat utf8.txt)

option(SDLTEST_TRACKMEM "Run tests with --trackmem" OFF)

if(WIN32)
    option(SDLTEST_PROCDUMP "Run tests using sdlprocdump for minidump generation" OFF)
    add_executable(sdlprocdump win32/sdlprocdump.c)
    set_property(TARGET sdlprocdump PROPERTY C_STANDARD "90")
    SDL_AddCommonCompilerFlags(sdlprocdump)
    if(SDLTEST_PROCDUMP)
        set(CMAKE_TEST_LAUNCHER "$<TARGET_FILE:sdlprocdump>;--")
    else()
        set_property(TARGET sdlprocdump PROPERTY EXCLUDE_FROM_ALL "1")
    endif()
endif()

if(EMSCRIPTEN)
    set(SDLTEST_BROWSER "firefox" CACHE STRING "Browser in which to run SDL unit tests (chrome or firefox)")
    set(SDLTEST_PORT "8080" CACHE STRING "Port on which to serve the tests")
    set(SDLTEST_CHROME_BINARY "" CACHE STRING "Chrome/Chromium browser binary (optional)")
    if(TARGET Python3::Interpreter)
        add_custom_target(serve-sdl-tests
                COMMAND Python3::Interpreter "${CMAKE_CURRENT_SOURCE_DIR}/emscripten/server.py"
                "${SDLTEST_PORT}"
                -d "${CMAKE_CURRENT_BINARY_DIR}"
                --map "${SDL3_SOURCE_DIR}:/SDL")
    endif()
endif()

if(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    set(test_bin_dir "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    if(NOT IS_ABSOLUTE "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
        set(test_bin_dir "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
    endif()
else()
    set(test_bin_dir "${CMAKE_CURRENT_BINARY_DIR}")
endif()
if(NOT CMAKE_VERSION VERSION_LESS 3.20)
    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    set(test_bin_dir "${test_bin_dir}$<$<BOOL:${is_multi_config}>:/$<CONFIG>>")
endif()

set(RESOURCE_FILE_NAMES)
set(RESOURCE_FILES_BINDIR)
foreach(resource_file IN LISTS RESOURCE_FILES)
    get_filename_component(res_file_name ${resource_file} NAME)
    list(APPEND RESOURCE_FILE_NAMES "${res_file_name}")
    set(resource_file_bindir "${test_bin_dir}/${res_file_name}")
    add_custom_command(OUTPUT "${resource_file_bindir}"
        COMMAND "${CMAKE_COMMAND}" -E copy "${resource_file}" "${resource_file_bindir}"
        DEPENDS "${resource_file}"
    )
    list(APPEND RESOURCE_FILES_BINDIR "${resource_file_bindir}")
endforeach()
add_custom_target(copy-sdl-test-resources
    DEPENDS "${RESOURCE_FILES_BINDIR}"
)

define_property(TARGET PROPERTY SDL_NONINTERACTIVE BRIEF_DOCS "If true, target is a non-interactive test executable." FULL_DOCS "If true, target is a noninteractive test executable.")
define_property(TARGET PROPERTY SDL_NONINTERACTIVE_ARGUMENTS BRIEF_DOCS "Argument(s) to run executable in non-interactive mode." FULL_DOCS "Argument(s) to run executable in non-interactive mode.")
define_property(TARGET PROPERTY SDL_NONINTERACTIVE_TIMEOUT BRIEF_DOCS "Timeout for noninteractive executable." FULL_DOCS "Timeout for noninteractive executable.")

macro(add_sdl_test_executable TARGET)
    cmake_parse_arguments(AST "BUILD_DEPENDENT;NONINTERACTIVE;NEEDS_RESOURCES;TESTUTILS;THREADS;NO_C90;MAIN_CALLBACKS;NOTRACKMEM" "" "DEPENDS;DISABLE_THREADS_ARGS;NONINTERACTIVE_TIMEOUT;NONINTERACTIVE_ARGS;INSTALLED_ARGS;SOURCES" ${ARGN})
    if(AST_UNPARSED_ARGUMENTS)
        message(FATAL_ERROR "Unknown argument(s): ${AST_UNPARSED_ARGUMENTS}")
    endif()
    if(NOT AST_SOURCES)
        message(FATAL_ERROR "add_sdl_test_executable needs at least one source")
    endif()
    if(AST_TESTUTILS)
        list(APPEND AST_SOURCES $<TARGET_OBJECTS:sdltests_utils>)
    endif()
    set(EXTRA_SOURCES "")
    if(AST_NEEDS_RESOURCES)
        list(APPEND EXTRA_SOURCES ${RESOURCE_FILES})
    endif()
    if(ANDROID)
        add_library(${TARGET} SHARED ${AST_SOURCES} ${EXTRA_SOURCES})
    else()
        add_executable(${TARGET} ${AST_SOURCES} ${EXTRA_SOURCES})
    endif()
    target_compile_definitions(${TARGET} PRIVATE HAVE_BUILD_CONFIG)
    SDL_AddCommonCompilerFlags(${TARGET})
    target_include_directories(${TARGET} PRIVATE "${SDL3_SOURCE_DIR}/src/video/khronos")
    target_link_libraries(${TARGET} PRIVATE SDL3::SDL3_test SDL3::${sdl_name_component})
    if(NOT AST_NO_C90 AND NOT SDL_CMAKE_PLATFORM MATCHES "^(n3ds|ps2|psp)$")
        set_property(TARGET ${TARGET} PROPERTY C_STANDARD 90)
        set_property(TARGET ${TARGET} PROPERTY C_EXTENSIONS FALSE)
    endif()
    if(AST_DEPENDS)
        add_dependencies(${TARGET} ${AST_DEPENDS})
    endif()

    list(APPEND SDL_TEST_EXECUTABLES ${TARGET})
    set_property(TARGET ${TARGET} PROPERTY SDL_NOTRACKMEM ${AST_NOTRACKMEM})
    if(AST_NONINTERACTIVE)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE 1)
    endif()
    set_property(TARGET ${TARGET} PROPERTY SDL_DISABLE_THREADS_ARGS "${AST_DISABLE_THREADS_ARGS}")
    set_property(TARGET ${TARGET} PROPERTY SDL_THREADS "${AST_THREADS}")
    if(AST_NONINTERACTIVE_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE_ARGUMENTS "${AST_NONINTERACTIVE_ARGS}")
    endif()
    if(AST_INSTALLED_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_INSTALLED_ARGUMENTS "${AST_INSTALLED_ARGS}")
    elseif(AST_NONINTERACTIVE_ARGS)
        set_property(TARGET ${TARGET} PROPERTY SDL_INSTALLED_ARGUMENTS "${AST_NONINTERACTIVE_ARGS}")
    endif()
    if(AST_NONINTERACTIVE_TIMEOUT)
        set_property(TARGET ${TARGET} PROPERTY SDL_NONINTERACTIVE_TIMEOUT "${AST_NONINTERACTIVE_TIMEOUT}")
    endif()
    if(AST_NEEDS_RESOURCES)
        if(PSP OR PS2 OR N3DS)
            add_custom_command(TARGET ${TARGET} POST_BUILD
                COMMAND ${CMAKE_COMMAND} ARGS -E make_directory $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET}
                COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${RESOURCE_FILES} $<TARGET_FILE_DIR:${TARGET}>/sdl-${TARGET})
        else()
            add_dependencies(${TARGET} copy-sdl-test-resources)
        endif()
        if(APPLE)
            # Make sure resource files get installed into macOS/iOS .app bundles.
            set_target_properties(${TARGET} PROPERTIES RESOURCE "${RESOURCE_FILES}")
        endif()
        if(EMSCRIPTEN)
            foreach(res IN LISTS RESOURCE_FILES)
                get_filename_component(res_name "${res}" NAME)
                target_link_options(${TARGET} PRIVATE "SHELL:--embed-file ${res}@${res_name}")
                set_property(TARGET ${TARGET} APPEND PROPERTY LINK_DEPENDS "${res}")
            endforeach()
        endif()
        set_property(TARGET ${TARGET} APPEND PROPERTY ADDITIONAL_CLEAN_FILES "$<TARGET_FILE_DIR:${TARGET}>/$<JOIN:${RESOURCE_FILE_NAMES},$<SEMICOLON>$<TARGET_FILE_DIR:${TARGET}>/>")
    endif()
    if(AST_BUILD_DEPENDENT)
        target_include_directories(${TARGET} BEFORE PRIVATE $<TARGET_PROPERTY:SDL3::${sdl_name_component},INCLUDE_DIRECTORIES>)
        target_include_directories(${TARGET} BEFORE PRIVATE ${SDL3_SOURCE_DIR}/src)
        if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.20")
            target_include_directories(${TARGET} AFTER PRIVATE "${SDL3_SOURCE_DIR}/include/build_config")
        endif()
    endif()

    if(WINDOWS)
        # CET support was added in VS 16.7
        if(MSVC_VERSION GREATER 1926 AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32|x64")
            set_property(TARGET ${TARGET} APPEND_STRING PROPERTY LINK_FLAGS " -CETCOMPAT")
        endif()
    elseif(PSP)
        target_link_libraries(${TARGET} PRIVATE GL)
    elseif(EMSCRIPTEN)
        set_property(TARGET ${TARGET} PROPERTY SUFFIX ".html")
        target_link_options(${TARGET} PRIVATE "SHELL:--pre-js ${CMAKE_CURRENT_SOURCE_DIR}/emscripten/pre.js")
        target_link_options(${TARGET} PRIVATE "-sEXIT_RUNTIME=1")
        set_property(TARGET ${TARGET} APPEND PROPERTY LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/emscripten/pre.js")
    endif()

    if(OPENGL_FOUND)
        target_compile_definitions(${TARGET} PRIVATE HAVE_OPENGL)
    endif()

    # FIXME: only add "${SDL3_BINARY_DIR}/include-config-$<LOWER_CASE:$<CONFIG>>" + include paths of external dependencies
    target_include_directories(${TARGET} PRIVATE "$<TARGET_PROPERTY:SDL3::${sdl_name_component},INCLUDE_DIRECTORIES>")
endmacro()

check_include_file(signal.h HAVE_SIGNAL_H)
if(HAVE_SIGNAL_H)
    add_definitions(-DHAVE_SIGNAL_H)
endif()

check_include_file(libudev.h HAVE_LIBUDEV_H)
if(HAVE_LIBUDEV_H)
    add_definitions(-DHAVE_LIBUDEV_H)
endif()

function(files2headers OUTPUT)
    set(xxd "${SDL3_SOURCE_DIR}/cmake/xxd.py")
    set(inputs ${ARGN})
    set(outputs )
    foreach(input IN LISTS inputs)
        get_filename_component(file_we "${input}" NAME_WE)
        set(intermediate "${CMAKE_CURRENT_BINARY_DIR}/${file_we}.h")
        set(output "${CMAKE_CURRENT_SOURCE_DIR}/${file_we}.h")
        list(APPEND outputs "${output}")
        if(TARGET Python3::Interpreter AND NOT CMAKE_CROSSCOMPILING)
            list(APPEND outputs  "${intermediate}")
            # Don't add the 'output' header to the output, to avoid marking them as GENERATED
            # (generated files are removed when running the CLEAN target)
            add_custom_command(OUTPUT "${intermediate}"
                COMMAND Python3::Interpreter "${xxd}" -i "${CMAKE_CURRENT_SOURCE_DIR}/${input}" "-o" "${intermediate}"
                COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${intermediate}" "${output}"
                DEPENDS "${xxd}" "${bmp}"
            )
        endif()
    endforeach()
    set(${OUTPUT} "${outputs}" PARENT_SCOPE)
    add_custom_target(generate-${OUTPUT} DEPENDS ${outputs})
endfunction()

files2headers(gamepad_image_headers
    gamepad_axis_arrow.bmp
    gamepad_axis.bmp
    gamepad_back.bmp
    gamepad_battery.bmp
    gamepad_battery_wired.bmp
    gamepad_button_background.bmp
    gamepad_button.bmp
    gamepad_button_small.bmp
    gamepad_face_abxy.bmp
    gamepad_face_bayx.bmp
    gamepad_face_sony.bmp
    gamepad_front.bmp
    gamepad_touchpad.bmp
    gamepad_wired.bmp
    gamepad_wireless.bmp
)
files2headers(icon_bmp_header icon.bmp)
files2headers(glass_bmp_header glass.bmp)

set(FFmpeg_FIND_COMPONENTS AVCODEC AVFORMAT AVUTIL SWSCALE)
include("${CMAKE_CURRENT_LIST_DIR}/../cmake/FindFFmpeg.cmake")
if(FFmpeg_FOUND)
    cmake_push_check_state()
    list(APPEND CMAKE_REQUIRED_INCLUDES "${FFmpeg_AVUTIL_INCLUDE_DIRS}")
    list(APPEND CMAKE_REQUIRED_INCLUDES "${SDL3_SOURCE_DIR}/src/video/khronos")
    check_struct_has_member("AVFrame" "ch_layout" "libavutil/frame.h" LIBAVUTIL_AVFRAME_HAS_CH_LAYOUT)
    check_struct_has_member("AVVulkanFramesContext" "format" "libavutil/hwcontext_vulkan.h" LIBAVUTIL_AVFULKANFRAMESCONTEXT_HAS_FORMAT)
    cmake_pop_check_state()
endif()
if(FFmpeg_FOUND AND LIBAVUTIL_AVFRAME_HAS_CH_LAYOUT)
    add_sdl_test_executable(testffmpeg NO_C90 SOURCES testffmpeg.c testffmpeg_vulkan.c ${icon_bmp_header} DEPENDS generate-icon_bmp_header)
    if(LIBAVUTIL_AVFULKANFRAMESCONTEXT_HAS_FORMAT)
      target_compile_definitions(testffmpeg PRIVATE FFMPEG_VULKAN_SUPPORT)
    endif()
    if(APPLE)
        target_link_options(testffmpeg PRIVATE "-Wl,-framework,CoreVideo")
    endif()
    if(TARGET OpenGL::EGL)

=== debian/changelog ===
libsdl3 (3.2.4+git20250218+ds-1) experimental; urgency=medium

  * d/watch.git: Update
  * d/gbp.conf, d/watch: Watch for git snapshots
  * New upstream snapshot
  * d/copyright: Update
  * d/rules: Be more explicit about what we do and don't load dynamically
  * d/rules: Treat testtimer as flaky when running on non-x86, non-aarch64.
    There is an assertion that requesting a 1ms delay does not result in
    a delay of more than 100ms, and that isn't reliably true on slow
    machines like riscv64 or batch-processing-oriented machines like s390x,
    resulting in test failures.
    This makes those machines unsuitable for playing fast-paced SDL-based
    games, but we already knew that.

 -- Simon McVittie <smcv@debian.org>  Wed, 19 Feb 2025 15:33:50 +0000

## libsdl3 3.2.4+git20250228+ds

=== debian/changelog ===
libsdl3 (3.2.4+git20250228+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - Among many other changes, this fixes an audio capture regression
      with PulseAudio in versions since 2.30 (Closes: #1098900)
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Feb 2025 13:52:25 +0000

=== debian/control ===
--- 
+++ 
@@ -69,7 +69,7 @@
  libudev1 [linux-any],
 Suggests:
  libayatana-appindicator3-1 | libappindicator3-1,
- libpipewire-0.3-0 [linux-any],
+ libpipewire-0.3-0t64 [linux-any],
  liburing2 [linux-any],
  libvulkan1,
  xdg-utils,
@@ -93,6 +93,7 @@
  libgl-dev,
  libgles-dev [!hurd-any],
  libibus-1.0-dev,
+ libpipewire-0.3-dev (>= 0.3.44) [linux-any],
  libpulse-dev,
  libsdl3-0 (= ${binary:Version}),
  libsndio-dev,

=== debian/watch ===
version=4
opts="\
    compression=xz, \
    dversionmangle=s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//, \
    mode=git, \
    pgpmode=none, \
    pretty=3.2.4+git%cd, \
    repack, \
    repacksuffix=+ds" \
https://github.com/libsdl-org/SDL.git \
HEAD

## libsdl3 3.2.6+ds

=== debian/changelog ===
libsdl3 (3.2.6+ds-1) unstable; urgency=medium

  * New upstream stable release
  * d/patches: Update to upstream 3.2.x branch commit
    release-3.2.6-5-g18d93d11e1, excluding macOS-specific changes

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Mar 2025 09:45:37 +0000

## libsdl3 3.2.8+ds

=== debian/changelog ===
libsdl3 (3.2.8+ds-1) unstable; urgency=medium

  * New upstream stable release
  * Drop patches, applied upstream
  * Standards-Version: 4.7.2 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Wed, 05 Mar 2025 10:24:27 +0000
